var G_GOING_STR = "I'm Going!";
var G_NOT_GOING_STR = "Not Going";

function loadCSV()
{
    var xmlhttp = new XMLHttpRequest();
    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
            // window.alert(xmlhtp.responseText);
            loadHTMLTable(xmlhttp.responseText);
        }
    }
    xmlhttp.open("GET", "checkins.csv", true);
    xmlhttp.send();
}

function loadHTMLTable(data)
{
    var tableTag = document.getElementById("poolmembers");
    tableTag.innerHTML = "";   // Clear

    var tableRowTags = '<tr>\n';
    tableRowTags += '<th>Id</th>\n';
    tableRowTags += '<th>Pool Group Member</th>\n';
    tableRowTags += '<th>Home Town</th>\n';
    tableRowTags += '<th>Attendance</th>\n';
    tableRowTags += '<th></th>\n';
    tableRowTags += '<th></th>\n';
    tableRowTags += '</tr>\n';

    var numGoing = 0;
    var numNotGoing = 0;
    var allrows = data.split('\n');
    for (row = 0; row < allrows.length; row++) { 
        var rowFields = allrows[row].split(',');

        // store away the date and time stamps to custom data attributes on the <tr> tag
        if (rowFields.length >= 2) {
            tableRowTags += "<tr data-datestamp='" + rowFields[0] + "' " + "data-timestamp='" + rowFields[1] + "'>\n";
        }

        for (field = 2; field < rowFields.length; field++) {
            // window.alert("rowFields[" + field + "]=<" + rowFields[field] + ">");
            if (field == 5) {        // if attendance field
            	if (rowFields[field] == '1') {
                    tableRowTags += "<td style='color:blue'>" + G_GOING_STR + "</td>\n";
                    numGoing++;
                }
            	else if (rowFields[field] == '2') {
                    tableRowTags += "<td style='color:red'>" + G_NOT_GOING_STR + "</td>\n";
                    numNotGoing++;
                }
                else {
                    tableRowTags += "<td></td>\n";
                }
            }
            else {
            	tableRowTags += "<td>" + rowFields[field] + "</td>\n";
            }
        }

        if (field > 2) {
            // add the [Attending] button
            tableRowTags += "<td>";
            tableRowTags += '<button onclick="attend(' + rowFields[2] + ', 1);"> Attending </button>';
            tableRowTags += "</td>\n";

            // add the [Not Attending] button
            tableRowTags += "<td>";
            tableRowTags += '<button onclick="attend(' + rowFields[2] + ', 2);"> Not Attending </button>';
            tableRowTags += "</td>\n";
        }

        tableRowTags += "</tr>\n";
    }
    tableTag.innerHTML += tableRowTags;

    // update the total number of members going and NOT going
    var totalGoingTag = document.getElementById("totalgoing");
    totalGoingTag.innerHTML = numGoing.toString();
    var totalNotGoingTag = document.getElementById("totalnotgoing");
    totalNotGoingTag.innerHTML = numNotGoing.toString();
}

function attend(userid, attendOrNot)
{
    var tableTag = document.getElementById("poolmembers");

    // update the total number of members going and not going
    var totalGoingTag = document.getElementById("totalgoing");
    var numGoing = parseInt(totalGoingTag.innerHTML, 10);
    var totalNotGoingTag = document.getElementById("totalnotgoing");
    var numNotGoing = parseInt(totalNotGoingTag.innerHTML, 10);

    // update the <td> tag for this userid
    var writeOutData = 1;
    var tdTag = tableTag.rows[userid].cells[3];
    var oldVal = tdTag.innerHTML;
    if (attendOrNot == '1') {
        if (oldVal === G_NOT_GOING_STR) {
            numNotGoing--;
        }

        if (oldVal !== G_GOING_STR) {
            tdTag.innerHTML = G_GOING_STR;
            tdTag.style.color = 'blue';
            numGoing++;
        }
	else {
            writeOutData = 0;
        }
    }
    else if (attendOrNot == '2') {
        if (oldVal === G_NOT_GOING_STR) {
            tdTag.innerHTML = "";
        }
        else if (oldVal === G_GOING_STR) {
            tdTag.innerHTML = G_NOT_GOING_STR;
            tdTag.style.color = 'red';
            numNotGoing++;
            numGoing--;
        }
        else {
            tdTag.innerHTML = G_NOT_GOING_STR;
            tdTag.style.color = 'red';
        }
    }
    else {
        tdTag.innerHTML = "";
    }

    if (writeOutData) {
        // update the <tr> tag with the current date and time stamps
        var today = new Date();
        var currDate = today.getFullYear() + "/" + (today.getMonth()+1) + "/" + today.getDate();
        var currTime = today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds();

        var trTag = tableTag.rows[userid];
        trTag.setAttribute('data-datestamp', currDate);
        trTag.setAttribute('data-timestamp', currTime);

        var strNumGoing = numGoing.toString();
        totalGoingTag.innerHTML = strNumGoing;

        var strNumNotGoing = numNotGoing.toString();
        totalNotGoingTag.innerHTML = strNumNotGoing;

        // write out the table's data to CSV file
        writeCSV();

        // send out an e-mail to the group organizer
        var strUser = tableTag.rows[userid].cells[1].innerHTML;
        var strBody = strUser;
        if (tdTag.innerHTML == G_GOING_STR) {
            strBody += ' is attending pool this week.';
        }
        else if (tdTag.innerHTML == G_NOT_GOING_STR) {
            strBody += ' is NOT attending pool this week.';
        }
        else {
            strBody += ' reset the attendance field.';
        }
        var strSubject = strBody;
        strBody += '\r\nA total of ' + strNumGoing + ' members are going.';
        strBody += '\r\nA total of ' + strNumNotGoing + ' members are NOT going.';

        var subjectParam = "s=" + encodeURIComponent(strSubject);
        var bodyParam = "b=" + encodeURIComponent(strBody);
        var strParams = subjectParam + "&" + bodyParam;
        var xmlhttp = new XMLHttpRequest();
        xmlhttp.onreadystatechange = function() {
            if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
                console.log(xmlhttp.responseText);
            }
        }
        xmlhttp.open("POST", "sendTextMessage.php", true);
        xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        xmlhttp.setRequestHeader("Content-length", strParams.length);
        xmlhttp.send(strParams);

        //var mailtoLink = 'mailto:davidbrink@mindspring.com' +
        //                 '?subject=' + strSubject +
        //                 '&body=' + strBody;
        //window.location.href = mailtoLink;
        //window.alert(mailtoLink);
    }
}

function writeCSV()
{
    var csvString = "";
    var tableTag = document.getElementById("poolmembers");

    // traverse the table tag row by row skipping the header row
    for (var rowNum=1, row; row = tableTag.rows[rowNum]; rowNum++) {
        if (row.cells.length > 0) {
            // add current date and time first
            csvString += row.getAttribute('data-datestamp') + ",";
            csvString += row.getAttribute('data-timestamp') + ",";
        }

        // traverse each cell skipping the last two button cells
        for (var cellNum = 0, col; col = row.cells[cellNum]; cellNum++) {
            if (cellNum < row.cells.length-3) { // if not last cell in row
                csvString += col.innerHTML;  // add cell data
                csvString += ",";
            }
            else {
                if (col.innerHTML === G_GOING_STR)
                   csvString += "1";
                else if (col.innerHTML === G_NOT_GOING_STR)
                   csvString += "2";
                else
                   csvString += "0";
                break;
            }
        }  
        if (tableTag.rows[rowNum+1]) {
            csvString += "\n";
        }
    }
    // window.alert(csvString);

    // write out the built csv string to the csv file
    var data = "q=" + encodeURIComponent(csvString);
    var xmlhttp = new XMLHttpRequest();
    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
            console.log(xmlhttp.responseText);
        }
    }
    xmlhttp.open("POST", "writeToCheckinFile.php", true);
    xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    xmlhttp.setRequestHeader("Content-length", data.length);
    xmlhttp.send(data);
}
